From: Leif Lindholm <leif.lindholm@linaro.org>
To: edk2-devel@lists.01.org
Cc: Liming Gao <liming.gao@intel.com>, Yonghong Zhu <yonghong.zhu@intel.com>
Subject: [PATCH 1/2] edksetup.sh: rework argument parsing and update usage information
Date: Thu, 20 Oct 2016 16:46:24 +0100 [thread overview]
Message-ID: <20161020154625.31352-2-leif.lindholm@linaro.org> (raw)
In-Reply-To: <20161020154625.31352-1-leif.lindholm@linaro.org>
Rework the argument parsing logic to a more extensible traditional
while/case setup to prepare for further additions.
While doing that, align the Usage printout to look a bit more like
the output of Edk2Setup.bat (and be more correct).
And also stop passing around command line options to the BuildEnv
script (which does not check them anyway).
Contributed-under: TianoCore Contribution Agreement 1.0
Signed-off-by: Leif Lindholm <leif.lindholm@linaro.org>
---
edksetup.sh | 65 +++++++++++++++++++++++++++++++++++--------------------------
1 file changed, 37 insertions(+), 28 deletions(-)
diff --git a/edksetup.sh b/edksetup.sh
index 27c0994..7b54223 100755
--- a/edksetup.sh
+++ b/edksetup.sh
@@ -1,5 +1,6 @@
#
# Copyright (c) 2006 - 2016, Intel Corporation. All rights reserved.<BR>
+# Copyright (c) 2016, Linaro Ltd. All rights reserved.<BR>
# This program and the accompanying materials
# are licensed and made available under the terms and conditions of the BSD License
# which accompanies this distribution. The full text of the license may be found at
@@ -22,12 +23,21 @@
# Please reference edk2 user manual for more detail descriptions at https://github.com/tianocore-docs/Docs/raw/master/User_Docs/EDK_II_UserManual_0_7.pdf
#
+SCRIPTNAME="edksetup.sh"
+
function HelpMsg()
{
+ echo "Usage: $SCRIPTNAME [Options]"
+ echo
+ echo "The system environment variable, WORKSPACE, is always set to the current"
+ echo "working directory."
+ echo
+ echo "Options: "
+ echo " --help, -h, -? Print this help screen and exit."
+ echo
echo Please note: This script must be \'sourced\' so the environment can be changed.
- echo ". edksetup.sh"
- echo "source edksetup.sh"
- return 1
+ echo ". $SCRIPTNAME"
+ echo "source $SCRIPTNAME"
}
function SetWorkspace()
@@ -71,10 +81,10 @@ function SetupEnv()
{
if [ -n "$EDK_TOOLS_PATH" ]
then
- . $EDK_TOOLS_PATH/BuildEnv $*
+ . $EDK_TOOLS_PATH/BuildEnv
elif [ -f "$WORKSPACE/BaseTools/BuildEnv" ]
then
- . $WORKSPACE/BaseTools/BuildEnv $*
+ . $WORKSPACE/BaseTools/BuildEnv
elif [ -n "$PACKAGES_PATH" ]
then
PATH_LIST=$PACKAGES_PATH
@@ -84,7 +94,7 @@ function SetupEnv()
if [ -f "$DIR/BaseTools/BuildEnv" ]
then
export EDK_TOOLS_PATH=$DIR/BaseTools
- . $DIR/BaseTools/BuildEnv $*
+ . $DIR/BaseTools/BuildEnv
break
fi
done
@@ -99,32 +109,31 @@ function SetupEnv()
function SourceEnv()
{
- if [ \
- "$1" = "-?" -o \
- "$1" = "-h" -o \
- "$1" = "--help" \
- ]
- then
- HelpMsg
- else
- SetWorkspace &&
- SetupEnv "$*"
- fi
+ SetWorkspace &&
+ SetupEnv
}
-if [ $# -gt 1 ]
-then
- HelpMsg
-elif [ $# -eq 1 ] && [ "$1" != "BaseTools" ]
-then
- HelpMsg
-fi
+I=$#
+while [ $I -gt 0 ]
+do
+ case "$1" in
+ BaseTools)
+ # Ignore argument for backwards compatibility
+ shift
+ ;;
+ -?|-h|--help|*)
+ HelpMsg
+ break
+ ;;
+ esac
+ I=$(($I - 1))
+done
-RETVAL=$?
-if [ $RETVAL -ne 0 ]
+if [ $I -gt 0 ]
then
- return $RETVAL
+ return 1
fi
-SourceEnv "$*"
+SourceEnv
+return $?
--
2.9.3
next prev parent reply other threads:[~2016-10-20 15:46 UTC|newest]
Thread overview: 5+ messages / expand[flat|nested] mbox.gz Atom feed top
2016-10-20 15:46 [PATCH 0/2] Add --reconfig option to edksetup.sh Leif Lindholm
2016-10-20 15:46 ` Leif Lindholm [this message]
2016-10-20 15:46 ` [PATCH 2/2] edksetup.sh, BaseTools/BuildEnv: add --reconfig support Leif Lindholm
2016-10-24 2:53 ` [PATCH 0/2] Add --reconfig option to edksetup.sh Gao, Liming
2016-10-24 12:56 ` Leif Lindholm
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-list from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20161020154625.31352-2-leif.lindholm@linaro.org \
--to=devel@edk2.groups.io \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox